package beispielapp

import grails.converters.JSON
import grails.validation.ValidationException
import static org.springframework.http.HttpStatus.*

class AbhaengigkeitenController {

    AbhaengigkeitenService abhaengigkeitenService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond abhaengigkeitenService.list(params), model:[abhaengigkeitenCount: abhaengigkeitenService.count()]
    }

    def show(Long id) {
        respond abhaengigkeitenService.get(id)
    }

    def create() {
        respond new Abhaengigkeiten(params)
    }

    def save(Abhaengigkeiten abhaengigkeiten) {
        if (abhaengigkeiten == null) {
            notFound()
            return
        }

        try {
            abhaengigkeitenService.save(abhaengigkeiten)
        } catch (ValidationException e) {
            respond abhaengigkeiten.errors, view:'create'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'abhaengigkeiten.label', default: 'Abhaengigkeiten'), abhaengigkeiten.id])
                redirect abhaengigkeiten
            }
            '*' { respond abhaengigkeiten, [status: CREATED] }
        }
    }

    def edit(Long id) {
        respond abhaengigkeitenService.get(id)
    }

    def update(Abhaengigkeiten abhaengigkeiten) {
        if (abhaengigkeiten == null) {
            notFound()
            return
        }

        try {
            abhaengigkeitenService.save(abhaengigkeiten)
        } catch (ValidationException e) {
            respond abhaengigkeiten.errors, view:'edit'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'abhaengigkeiten.label', default: 'Abhaengigkeiten'), abhaengigkeiten.id])
                redirect abhaengigkeiten
            }
            '*'{ respond abhaengigkeiten, [status: OK] }
        }
    }

    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        abhaengigkeitenService.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'abhaengigkeiten.label', default: 'Abhaengigkeiten'), id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'abhaengigkeiten.label', default: 'Abhaengigkeiten'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }
}
